[HOT 100] 2824. 统计和小于目标的下标对数目

文章目录

      • [1. 题目链接](#1. 题目链接)
      • [2. 题目描述](#2. 题目描述)
      • [3. 题目示例](#3. 题目示例)
      • [4. 解题思路](#4. 解题思路)
      • [5. 题解代码](#5. 题解代码)
      • [6. 复杂度分析](#6. 复杂度分析)

1. 题目链接

2824. 统计和小于目标的下标对数目 - 力扣(LeetCode)

2. 题目描述

给你一个下标从 0 开始长度为 n 的整数数组 nums 和一个整数 target ,请你返回满足 0 <= i < j < n 且 nums[i] + nums[j] < target 的下标对 (i, j) 的数目。

3. 题目示例

示例 1 :

plain 复制代码
输入:nums = [-1,1,2,3,1], target = 2
输出:3
解释:总共有 3 个下标对满足题目描述:
- (0, 1) ,0 < 1 且 nums[0] + nums[1] = 0 < target
- (0, 2) ,0 < 2 且 nums[0] + nums[2] = 1 < target 
- (0, 4) ,0 < 4 且 nums[0] + nums[4] = 0 < target
注意 (0, 3) 不计入答案因为 nums[0] + nums[3] 不是严格小于 target 。

示例 2 :

plain 复制代码
输入:nums = [-6,2,5,-2,-7,-1,3], target = -2
输出:10
解释:总共有 10 个下标对满足题目描述:
- (0, 1) ,0 < 1 且 nums[0] + nums[1] = -4 < target
- (0, 3) ,0 < 3 且 nums[0] + nums[3] = -8 < target
- (0, 4) ,0 < 4 且 nums[0] + nums[4] = -13 < target
- (0, 5) ,0 < 5 且 nums[0] + nums[5] = -7 < target
- (0, 6) ,0 < 6 且 nums[0] + nums[6] = -3 < target
- (1, 4) ,1 < 4 且 nums[1] + nums[4] = -5 < target
- (3, 4) ,3 < 4 且 nums[3] + nums[4] = -9 < target
- (3, 5) ,3 < 5 且 nums[3] + nums[5] = -3 < target
- (4, 5) ,4 < 5 且 nums[4] + nums[5] = -8 < target
- (4, 6) ,4 < 6 且 nums[4] + nums[6] = -4 < target

4. 解题思路

  • 排序 :首先对 nums 排序是必要的,因为双指针法要求我们能够从两端开始有效地比较数字。
  • 双指针 :使用 left 指向数组的最小元素,right 指向数组的最大元素。然后判断 nums[left] + nums[right] 是否小于 target:
    • 如果小于:说明从 left 到 right-1 的所有元素和当前 nums[right] 组合都是有效的,所以直接增加 (right - left) 个有效组合。
    • 如果大于或等于:则减小右指针 right--,继续尝试小一些的元素。
  • 返回结果 :最终返回计数 ans,即满足条件的 (i, j) 对的数目。

5. 题解代码

java 复制代码
class Solution {
    public int countPairs(List<Integer> nums, int target) {
        int left = 0, right = nums.size() - 1, ans = 0;
        Collections.sort(nums);  // 排序
        while (left < right) {
            int sum = nums.get(left) + nums.get(right);
            if (sum < target) {
                // 如果 nums[left] + nums[right] < target
                // 说明从 left 到 right 之间的所有数与 right 配对都是有效的
                ans += (right - left);  // 所以增加 right - left 对
                left++;  // 左指针右移
            } else {
                // 如果和大于或等于 target,右指针左移
                right--;
            }
        }
        return ans;
    }
}

6. 复杂度分析

  • 时间复杂度: 排序的时间复杂度是 O(nlogn),双指针的遍历是 O(n),所以时间复杂度是 O(nlogn)。
  • 空间复杂度: 只使用了常数空间,所以空间复杂度是 O(1)。
相关推荐
动词ing9 分钟前
【题目练习】外观数列
算法
余额瞒着我当琳10 分钟前
C++11,发展历史浅谈,初始化列表和对象初始化,右值引用和移动语义
java·开发语言·c++·算法
suhan23 分钟前
【数据结构】六、图:4.图的遍历(深度优先算法DFS、广度优先算法BFS)
数据结构·算法·排序算法
suhan24 分钟前
【数据结构】六、图:3.十字链表、邻接多重表、边集数组
数据结构·算法·排序算法
Dola_Zou28 分钟前
工商业储能系统核心策略
算法·自动化·软件工程
Tsuki_tl28 分钟前
【优选算法:双指针】——复写零题解
java·c++·算法·leetcode·数组·双指针·复写零
Rain的Java大神之路1 小时前
面了上百人,我最爱问的LeetCode 1「两数之和」:能背代码的很多,能讲清“先查后存”的没几个
java·后端·算法
Ivanqhz1 小时前
超参数考量与设计
数据库·人工智能·深度学习·算法·机器学习
雪落漂泊1 小时前
C++算法 滑动窗口篇(上)
开发语言·c++·算法
吞下星星的少年·-·1 小时前
Div.2 CF edu195A题(数学,贪心)
数学·算法·贪心